Name:           qlcplus
Version:        4.14.3
Release:        1%{?dist}
Summary:        Q Light Controller Plus

License:        Apache-2.0
URL:            https://www.qlcplus.org/
Source0:        https://github.com/mcallegari/qlcplus/archive/QLC+_%{version}/%{name}-%{version}.tar.gz

BuildRequires:  cmake
BuildRequires:  cmake(Qt5)
BuildRequires:  cmake(Qt5LinguistTools)
BuildRequires:  cmake(Qt5Multimedia)
BuildRequires:  cmake(Qt5Script)
BuildRequires:  cmake(Qt5SerialPort)
BuildRequires:  cmake(Qt5Svg)
BuildRequires:  cmake(Qt5WebSockets)
BuildRequires:  desktop-file-utils
BuildRequires:  gcc-c++
BuildRequires:  pkgconfig(alsa)
BuildRequires:  pkgconfig(fftw3)
BuildRequires:  pkgconfig(libftdi1)
BuildRequires:  pkgconfig(libudev)
BuildRequires:  pkgconfig(libusb-1.0)
BuildRequires:  pkgconfig(sndfile)

Requires:       systemd-udev
Requires:       qt5-filesystem

%description
QLC+ is powerful and user-friendly software designed to control DMX lighting.
Whether you're an experienced lighting professional or just getting started,
QLC+ empowers you to take control of your lighting fixtures with ease. The
primary goal of this project is to bring QLC+ to the level of available
commercial software.


%prep
%autosetup -n qlcplus-QLC-_%{version}

sed -i -e '/UDEVRULESDIR/s|/etc/udev/rules.d|%{_udevrulesdir}|' variables.cmake

# Use static linking of the applications internal modules, without exposing them as dynamic libraries:
sed -i -ze 's,\<add_library(${module_name}[ \r\n]\+SHARED\>,add_library(${module_name} STATIC,g' {engine,ui,webaccess}/src/CMakeLists.txt

%build
%cmake
%cmake_build


%install
%cmake_install

# With Qt5, GNOME finds icons for running application using reversed OrganizationDomain
mv %{buildroot}/%{_datadir}/applications/{,net.sf.}qlcplus-fixtureeditor.desktop
mv %{buildroot}/%{_datadir}/applications/{,net.sf.}qlcplus.desktop

desktop-file-validate %{buildroot}/%{_datadir}/applications/*.desktop

%check
cd "%{__cmake_builddir}"
make unittests

%files
%license COPYING
%doc README.md
%{_bindir}/qlcplus
%{_bindir}/qlcplus-fixtureeditor
%{_datadir}/applications/*qlcplus*.desktop
%{_mandir}/man1/qlcplus*.1.gz
%{_datadir}/metainfo/org.qlcplus.QLCPlus*
%{_datadir}/mime/packages/qlcplus.xml
%{_datadir}/pixmaps/qlcplus*
%{_datadir}/qlcplus/
%{_libdir}/qt5/plugins/qlcplus/
%{_udevrulesdir}/z65-*.rules
%exclude %{_libdir}/libqlcplus*.a


%changelog
* Sat Sep 07 2024 Mads Kiilerich <mads@kiilerich.com> - 4.14.3-1
- Initial Fedora package
